package de.towerdefence.server.server.channels.match.placing;

import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.node.JsonNodeFactory;

import de.towerdefence.server.match.exeptions.InvalidPlacementReason;
import de.towerdefence.server.server.JsonMessage;
import lombok.AllArgsConstructor;

import java.util.Map;

@AllArgsConstructor
public class InvalidPlacementMessage extends JsonMessage {

    private final int x;
    private final int y;
    private final InvalidPlacementReason reason;

    @Override
    protected String getMessageId() {
        return "InvalidPlacement";
    }

    @Override
    protected Map<String, JsonNode> getData(JsonNodeFactory factory) {
        return Map.of(
                "x", factory.numberNode(this.x),
                "y", factory.numberNode(this.y),
                "reason", factory.textNode(this.reason.getJsonName()));
    }
}
